IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'TRILHAUDIT_INSPECPROD' AND
                TYPE   = 'TR'               AND
                U.UID  = O.UID              AND
                U.NAME = USER)

DROP TRIGGER TRILHAUDIT_INSPECPROD
GO

CREATE TRIGGER TRILHAUDIT_INSPECPROD
ON INSPECPROD
FOR UPDATE,INSERT, DELETE
AS
BEGIN
   DECLARE @V_NRSEQTRILHA  NUMERIC(10);
   DECLARE @V_NMPRODUTO    VARCHAR(50);
   DECLARE @V_TIPOPROC     VARCHAR(50);
   DECLARE @V_NMINSPECAO   VARCHAR(50);
   DECLARE @V_ITEMALTERADO VARCHAR(300);
   DECLARE @V_NEWDESC      VARCHAR(300);
   DECLARE @V_OLDDESC      VARCHAR(300);
   DECLARE @V_CDOPERADOR   VARCHAR(12);
   DECLARE @V_CLIENT_INFO  VARCHAR(64);
   DECLARE @V_TIPO         VARCHAR(1);
   DECLARE @V_DSREMOTEADDR VARCHAR(15);
   DECLARE @V_DSREMOTEHOST VARCHAR(15);
   DECLARE @V_DSSERVERRDM  VARCHAR(20);
   DECLARE @V_DSSERVMETHOD VARCHAR(30);
   DECLARE @V_DSREMOTEOPER VARCHAR(12);

   DECLARE @V_CDPRODUTO_NEW      VARCHAR(10);
   DECLARE @V_CDINSPECAO_NEW     VARCHAR(10);
   DECLARE @V_NRSEQINSPRO_NEW    VARCHAR(3);
   DECLARE @V_CDSETOR_NEW        VARCHAR(4);
   DECLARE @V_IDPROCPROD_NEW     VARCHAR(1);
   DECLARE @V_IDSTATUSINSPEC_NEW VARCHAR(1);
   DECLARE @V_DTINCLUSAO_NEW     DATE;
   DECLARE @V_CDOPERINCLUSAO_NEW VARCHAR(12);
   DECLARE @V_IDATIVO_NEW        VARCHAR(1);

   DECLARE @V_CDPRODUTO_OLD      VARCHAR(10);
   DECLARE @V_CDINSPECAO_OLD     VARCHAR(10);
   DECLARE @V_NRSEQINSPRO_OLD    VARCHAR(3);
   DECLARE @V_CDSETOR_OLD        VARCHAR(4);
   DECLARE @V_IDPROCPROD_OLD     VARCHAR(1);
   DECLARE @V_IDSTATUSINSPEC_OLD VARCHAR(1);
   DECLARE @V_DTINCLUSAO_OLD     DATE;
   DECLARE @V_CDOPERINCLUSAO_OLD VARCHAR(12);
   DECLARE @V_IDATIVO_OLD        VARCHAR(1);


   SET @V_ITEMALTERADO = '';

   DECLARE C_CURSOR_I CURSOR FOR
      SELECT
         'E' IDCOMANDO,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL,
         CDPRODUTO,
         CDINSPECAO,
         NRSEQINSPRO,
         CDSETOR,
         IDPROCPROD,
         IDSTATUSINSPEC,
         NULL,
         NULL,
         NULL
      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'A' IDCOMANDO,
         INSERTED.CDPRODUTO,
         INSERTED.CDINSPECAO,
         INSERTED.NRSEQINSPRO,
         INSERTED.CDSETOR,
         INSERTED.IDPROCPROD,
         INSERTED.IDSTATUSINSPEC,
         NULL,
         NULL,
         NULL,

         DELETED.CDPRODUTO,
         DELETED.CDINSPECAO,
         DELETED.NRSEQINSPRO,
         DELETED.CDSETOR,
         DELETED.IDPROCPROD,
         DELETED.IDSTATUSINSPEC,
         NULL,
         NULL,
         NULL

      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDPRODUTO = DELETED.CDPRODUTO AND
         INSERTED.IDPROCPROD = DELETED.IDPROCPROD

      UNION ALL

      SELECT
         'I' IDCOMANDO,
         INSERTED.CDPRODUTO,
         INSERTED.CDINSPECAO,
         INSERTED.NRSEQINSPRO,
         INSERTED.CDSETOR,
         INSERTED.IDPROCPROD,
         INSERTED.IDSTATUSINSPEC,
         NULL,
         NULL,
         NULL,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED)
      OPEN C_CURSOR_I;

      FETCH NEXT FROM C_CURSOR_I INTO @V_TIPO, @V_CDPRODUTO_NEW, @V_CDINSPECAO_NEW, @V_NRSEQINSPRO_NEW,
                                      @V_CDSETOR_NEW, @V_IDPROCPROD_NEW, @V_IDSTATUSINSPEC_NEW, @V_DTINCLUSAO_NEW,
                                      @V_CDOPERINCLUSAO_NEW, @V_IDATIVO_NEW,

                                      @V_CDPRODUTO_OLD, @V_CDINSPECAO_OLD, @V_NRSEQINSPRO_OLD,
                                      @V_CDSETOR_OLD, @V_IDPROCPROD_OLD, @V_IDSTATUSINSPEC_OLD, @V_DTINCLUSAO_OLD,
                                      @V_CDOPERINCLUSAO_OLD, @V_IDATIVO_OLD;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         IF (@V_TIPO = 'E') BEGIN
            SET @V_ITEMALTERADO = 'Excluso de Inspeo';

            EXEC WEBTUNNING @V_DSREMOTEADDR,
                            @V_DSREMOTEHOST,
                            @V_DSSERVERRDM,
                            @V_DSSERVMETHOD,
                            @V_DSREMOTEOPER;

            SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
             FROM TRILHAUDIT;

            SELECT @V_NMPRODUTO = NMPRODUTO
              FROM PRODUTO
             WHERE CDPRODUTO = @V_CDPRODUTO_OLD;

            SELECT @V_NMINSPECAO = NMINSPECAO
              FROM INSPECAO
             WHERE CDINSPECAO = @V_CDINSPECAO_OLD;

            INSERT INTO TRILHAUDIT
             (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
            VALUES
             (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, 'E', GETDATE(), NULL, 'Excluso da Inspeo: ' + @V_NMINSPECAO, @V_DSREMOTEOPER, @V_ITEMALTERADO);
         END
         ELSE IF (@V_TIPO = 'I') BEGIN
            SET @V_ITEMALTERADO = 'Insero';

            IF (@V_IDPROCPROD_NEW = 'A') BEGIN
               SET @V_TIPOPROC = 'Produto Acabado';
            END
            ELSE IF (@V_IDPROCPROD_NEW = 'M') BEGIN
               SET @V_TIPOPROC = 'Matria Prima';
            END
            ELSE IF (@V_IDPROCPROD_NEW = 'P') BEGIN
               SET @V_TIPOPROC = 'Produto em Processo';
            END
            ELSE IF (@V_IDPROCPROD_NEW = 'E') BEGIN
               SET @V_TIPOPROC = 'Material de Embalagem';
            END
            ELSE BEGIN
               SET @V_TIPOPROC = 'No se Aplica';
            END;
            
            EXEC WEBTUNNING @V_DSREMOTEADDR,
                            @V_DSREMOTEHOST,
                            @V_DSSERVERRDM,
                            @V_DSSERVMETHOD,
                            @V_DSREMOTEOPER;

            SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
             FROM TRILHAUDIT;

            SELECT @V_NMPRODUTO = NMPRODUTO
              FROM PRODUTO
             WHERE CDPRODUTO = @V_CDPRODUTO_NEW;

            INSERT INTO TRILHAUDIT
             (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
            VALUES
             (@V_NRSEQTRILHA, @V_CDPRODUTO_NEW, @V_IDPROCPROD_NEW, 'I', GETDATE(), NULL, 'Insero do produto ' + @V_NMPRODUTO + ' - ' + @V_TIPOPROC + ', ' + 'Inspeo ' + @V_NMINSPECAO, @V_DSREMOTEOPER, @V_ITEMALTERADO);
         END
         ELSE BEGIN
            EXEC WEBTUNNING @V_DSREMOTEADDR,
                            @V_DSREMOTEHOST,
                            @V_DSSERVERRDM,
                            @V_DSSERVMETHOD,
                            @V_DSREMOTEOPER;

            IF (@V_CDPRODUTO_NEW <> @V_CDPRODUTO_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Produto';

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, 'A', GETDATE(), @V_CDPRODUTO_OLD, @V_CDPRODUTO_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_CDINSPECAO_NEW <> @V_CDINSPECAO_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Inspeo';

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, 'A', GETDATE(), @V_CDINSPECAO_OLD, @V_CDINSPECAO_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_NRSEQINSPRO_NEW <> @V_NRSEQINSPRO_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Cdigo';

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, 'A', GETDATE(), @V_NRSEQINSPRO_OLD, @V_NRSEQINSPRO_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_CDSETOR_NEW <> @V_CDSETOR_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Setor';

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               SELECT @V_NEWDESC = NMSETOR
                 FROM SETOR
                WHERE CDSETOR = @V_CDSETOR_NEW;

                SELECT @V_OLDDESC = NMSETOR
                 FROM SETOR
                WHERE CDSETOR = @V_CDSETOR_OLD;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, 'A', GETDATE(), @V_OLDDESC, @V_NEWDESC, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_IDPROCPROD_NEW <> @V_IDPROCPROD_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Processo';

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               IF (@V_IDPROCPROD_NEW = 'A') BEGIN
                  SET @V_NEWDESC = 'Produto Acabado';
               END
               ELSE IF (@V_IDPROCPROD_NEW = 'M') BEGIN
                  SET @V_NEWDESC = 'Matria Prima';
               END
               ELSE IF (@V_IDPROCPROD_NEW = 'P') BEGIN
                  SET @V_NEWDESC = 'Produto em Processo';
               END
               ELSE IF (@V_IDPROCPROD_NEW = 'E') BEGIN
                  SET @V_NEWDESC = 'Material de Embalagem';
               END
               ELSE BEGIN
                  SET @V_NEWDESC = 'No se Aplica';
               END;

               IF (@V_IDPROCPROD_OLD = 'A') BEGIN
                  SET @V_OLDDESC = 'Produto Acabado';
               END
               ELSE IF (@V_IDPROCPROD_OLD = 'M') BEGIN
                  SET @V_OLDDESC = 'Matria Prima';
               END
               ELSE IF (@V_IDPROCPROD_OLD = 'P') BEGIN
                  SET @V_OLDDESC = 'Produto em Processo';
               END
               ELSE IF (@V_IDPROCPROD_OLD = 'E') BEGIN
                  SET @V_OLDDESC = 'Material de Embalagem';
               END
               ELSE BEGIN
                  SET @V_OLDDESC = 'No se Aplica';
               END;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, 'A', GETDATE(), @V_OLDDESC, @V_NEWDESC, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_IDSTATUSINSPEC_NEW <> @V_IDSTATUSINSPEC_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Status da Inspeo';

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, 'A', GETDATE(), @V_IDSTATUSINSPEC_OLD, @V_IDSTATUSINSPEC_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_DTINCLUSAO_NEW <> @V_DTINCLUSAO_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Status da Inspeo';

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, 'A', GETDATE(), @V_DTINCLUSAO_OLD, @V_DTINCLUSAO_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_CDOPERINCLUSAO_NEW <> @V_CDOPERINCLUSAO_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Status da Inspeo';

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, 'A', GETDATE(), @V_CDOPERINCLUSAO_OLD, @V_CDOPERINCLUSAO_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_IDATIVO_NEW <> @V_IDATIVO_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Operador de Incluso';

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, 'A', GETDATE(), @V_IDATIVO_OLD, @V_IDATIVO_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

         END;

      FETCH NEXT FROM C_CURSOR_I INTO @V_TIPO, @V_CDPRODUTO_NEW, @V_CDINSPECAO_NEW, @V_NRSEQINSPRO_NEW,
                                      @V_CDSETOR_NEW, @V_IDPROCPROD_NEW, @V_IDSTATUSINSPEC_NEW, @V_DTINCLUSAO_NEW,
                                      @V_CDOPERINCLUSAO_NEW, @V_IDATIVO_NEW,

                                      @V_CDPRODUTO_OLD, @V_CDINSPECAO_OLD, @V_NRSEQINSPRO_OLD,
                                      @V_CDSETOR_OLD, @V_IDPROCPROD_OLD, @V_IDSTATUSINSPEC_OLD, @V_DTINCLUSAO_OLD,
                                      @V_CDOPERINCLUSAO_OLD, @V_IDATIVO_OLD;
    END;
    CLOSE C_CURSOR_I;
    DEALLOCATE C_CURSOR_I;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'TRILHAUDIT_INSPECPROD','6.05.xxx';
GO