IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'ETL_PLANEJADORA'  AND
	        TYPE = 'P' 			   AND
	        U.UID = O.UID             	   AND
	        U.NAME = USER)
  DROP PROCEDURE ETL_PLANEJADORA
  GO

CREATE PROCEDURE ETL_PLANEJADORA
AS
   DECLARE @V_CDFILIAL VARCHAR(4);
   DECLARE @V_SERVICOS VARCHAR(4000);
   DECLARE @V_DTINICIAL DATE;
   DECLARE @V_DTFINAL DATE;
   DECLARE @V_NRCONSPLAN VARCHAR(20);
   DECLARE @C_CDFILIAL VARCHAR(4);
   DECLARE @C_CDSERVFILI VARCHAR(5);
   DECLARE @C_DATAPROC DATE;
   DECLARE @C_DTPROC_INI DATE;
   DECLARE @C_DTPROC_FIM DATE;
BEGIN
   SET @V_CDFILIAL = NULL;
   SET @V_NRCONSPLAN = '';
   
   EXEC TEKNISA.NOVO_CODIGO 'ETL_CONSPLAN', @P_SEQUENCIAL = @V_NRCONSPLAN OUTPUT, @P_QTDE = 1;
   SET @V_NRCONSPLAN = SUBSTRING(@V_NRCONSPLAN, 11, 10); 
   
   DECLARE CUR_FILIAL CURSOR FOR 
      SELECT
          SE.CDFILIAL, 
          SE.CDSERVFILI, 
          PFI.DTPROCESSA DTPROC,
          DATEADD(MM,-1,PFI.DTPROCESSA) - DAY(PFI.DTPROCESSA)+1 DTPROC_INI,
          DATEADD(MM,2,PFI.DTPROCESSA) - DAY(PFI.DTPROCESSA) DTPROC_FIM 
       FROM
          SERVICO SE INNER JOIN (SELECT PF.CDFILIAL, CASE PG.IDUTILDTPROC WHEN 'N' THEN GETDATE() ELSE ISNULL(PF.DTPROCESSA,GETDATE())END DTPROCESSA 
                                      FROM PARAMGERAL PG, PARAMFILIAL PF) PFI ON (SE.CDFILIAL = PFI.CDFILIAL)
       WHERE ((SE.IDSERVPRINC = 'S') OR (SE.IDINDICADOR = 'S'))
       ORDER BY SE.CDFILIAL, SE.CDSERVFILI;
   OPEN CUR_FILIAL;
   FETCH NEXT FROM CUR_FILIAL  
    INTO @C_CDFILIAL, @C_CDSERVFILI, @C_DATAPROC, @C_DTPROC_INI, @C_DTPROC_FIM;
   WHILE (@@FETCH_STATUS = 0)   BEGIN
      IF (NOT @V_CDFILIAL IS NULL) AND (@V_CDFILIAL <> @C_CDFILIAL) BEGIN
             
         EXEC CONSUMO_PLANEJADO_PLA @V_CDFILIAL,
                                    @V_SERVICOS,
                                    @V_DTINICIAL,
                                    @V_DTFINAL,
                                    'T',   /* GRAVAC?O NA TABELA CONSPLAN */
                                    'CFP', /* CARDAPIO, CONSUMO FIXO E PERCAPITA */
                                    'N',   /* FOI INCLUIDO O PARAMETRO P_IDSEPPRATO */
                                    0,
                                    'N',
                                    @V_NRCONSPLAN,
                                    '0',
                                    'zzzzzzzzzz',
                                    '',
                                    NULL,--'_' + CONVERT(VARCHAR, @V_DTINICIAL,112) + '_',
                                    NULL;--'_' + CONVERT(VARCHAR, @V_DTFINAL,112) + '_';
                                    
         SET @V_SERVICOS = @C_CDSERVFILI; /*INICIA A VARIAVEL NOVAMENTE COM O VALOR DO PRIMEIRO SERVIO DA FILIAL*/
      END
      ELSE BEGIN
         SET @V_SERVICOS = @V_SERVICOS + '_' +  @C_CDSERVFILI; /*CONCATENA A LISTA DE SERVIOS COM OS SERVIOS PRINCIPAIS DE CADA FILIAL*/
      END;
      SET @V_CDFILIAL = @C_CDFILIAL;  /*ATUALIZA A VARIAVEL FILIAL*/
      SET @V_DTINICIAL = @C_DTPROC_INI;
      SET @V_DTFINAL = @C_DTPROC_FIM;
      FETCH NEXT FROM CUR_FILIAL 
       INTO @C_CDFILIAL, @C_CDSERVFILI, @C_DATAPROC, @C_DTPROC_INI, @C_DTPROC_FIM;
   END;
   CLOSE  CUR_FILIAL;
   DEALLOCATE CUR_FILIAL;
   /*CHAMA A CONSPLAN PARA A ULTIMA FILIAL DO LOOP*/
   EXEC CONSUMO_PLANEJADO_PLA @V_CDFILIAL,
                              @V_SERVICOS,
                              @V_DTINICIAL,
                              @V_DTFINAL,
                              'T',   /* GRAVAO NA TABELA CONSPLAN */
                              'CFP', /* CARDAPIO, CONSUMO FIXO E PERCAPITA */
                              'N',   /* FOI INCLUIDO O PARAMETRO P_IDSEPPRATO */
                              0,
                              'N',
                              @V_NRCONSPLAN,
                              '0',
                              'zzzzzzzzzz',
                              '',
                              NULL,--'_' + CONVERT(VARCHAR, @V_DTINICIAL,112) + '_',
                              NULL;--'_' + CONVERT(VARCHAR, @V_DTFINAL,112) + '_';
   
   /*LIMPA A TABELA DM_PLANEJADORA PARA ATUALIZAR AS INFORMAES NA MESMA*/
   DELETE FROM DM_PLANEJADORA;
   
   /*INSERE NA TABELA DM_PLANEJADORA TODAS AS INFORMACOES DAS FILIAIS E SERVIOS*/
   INSERT INTO DM_PLANEJADORA 
   (CDFILIAL, DTPROCESSA, CDSERVFILI, VRPUOBJETIVO, VRPUPLANEJADO, VRPUTENDENCIA, QTCOMESTMES, QTCOMESTPOS,
    QTEFETIVOS, VRDIFOBJPLA, VRDIFOBJTEND, VRPUPLAANT, VRPUREALANT, VRPUPLAPRXMES, VRREALCARD, VRPLACARD,
    PUREALDIAANT, PUPLADIAANT, VRPADMESANT)
   (SELECT CDFILIAL,
          DTPROC,
          CDSERVFILI,
          PU_OBJETIVO,
          ROUND((CASE ESTIMADOS_MES WHEN 0 THEN 0 ELSE (VRCUSTO_ATUAL / ESTIMADOS_MES) END),5) AS PU_PLANEJADO,
          ROUND((CASE (ESTIMADOS_POS_DTPROC + EFETIVOS) WHEN 0 THEN 0 ELSE (CUSTO_REAL_MES + VRCUSTO_POSDT) / (ESTIMADOS_POS_DTPROC + EFETIVOS) END),5) AS PU_TENDENCIA,
          ESTIMADOS_MES,
          ESTIMADOS_POS_DTPROC,
          EFETIVOS,
          ROUND(VRCUSTO_ATUAL - (PU_OBJETIVO * ESTIMADOS_MES),5) AS DIF_OBJ_PLA,
          ROUND((CUSTO_REAL_MES + VRCUSTO_POSDT) - (PU_OBJETIVO * ESTIMADOS_MES),5) DIF_OBJ_TEND,
          ROUND(CASE ESTIMADOS_ANT WHEN 0 THEN 0 ELSE (VRCUSTO_ANT / ESTIMADOS_ANT) END ,5) AS PU_PLAN_ANT,
          ROUND(CASE EFETIVOS_ANT WHEN 0 THEN 0 ELSE (CUSTO_REAL_ANT / EFETIVOS_ANT) END ,5) PU_REAL_ANT,
          ROUND(CASE ESTIMADOS_PROX_MES WHEN 0 THEN 0 ELSE (VRCUSTO_APOS / ESTIMADOS_PROX_MES) END,5) AS PU_PROX_MES,
          ROUND((CUSTO_REAL_MES_DTPROC_MENOS_UM), 5) AS VRREALCARD, /*CUSTO REALIZADO DO PRIMEIRO DIA DO MES DA DATA DE PROCESSAMENTO MENOS UM AT A DATA DE PROCESSAMENTO MENOS UM*/
          ROUND((CUSTO_PLA_MES_DTPROC_MENOS_UM), 5) AS VRPLACARD, /*CUSTO PLANEJADO DO PRIMEIRO DIA DO MES DA DATA DE PROCESSAMENTO MENOS UM AT A DATA DE PROCESSAMENTO MENOS UM*/ 
          ROUND(CASE EFETIVOS_DTPROC_MENOS_UM WHEN 0 THEN 0 ELSE (CUSTO_REAL_DTPROC_MENOS_UM / EFETIVOS_DTPROC_MENOS_UM) END, 5) AS PU_REAL_DTPROC_MENOS_UM,/*PU REALIZADO REFERENTE AO DIA ANTERIOR A DATA DE PROCESSAMENTO*/         
          ROUND(CASE ESTIMADOS_DTPROC_MENOS_UM WHEN 0 THEN 0 ELSE (CUSTO_PLA_DTPROC_MENOS_UM / ESTIMADOS_DTPROC_MENOS_UM) END, 5) AS PU_PLA_DTPROC_MENOS_UM,/*PU PLANEJADO REFERENTE AO DIA ANTERIOR A DATA DE PROCESSAMENTO*/
          (PU_PADR_MES_DTPROC_MENOS_UM) AS PU_PADR_MES_DTPROC_MENOS_UM /* CUSTO PADRAO REFERENTE AO MES DA DATA DE PROCESSAMENTO - 1*/          
    FROM
        (SELECT      
        SE.CDFILIAL, 
        CONVERT(DATETIME,PFI.DTPROCESSA) DTPROC,
        SE.CDSERVFILI,
        ISNULL(CPR.VRCUSTPADR,0) PU_OBJETIVO, /*CUSTO PADRAO OBJETIVO UNITARIO*/
        ISNULL(CARD.ESTIMADOS_MES,0) ESTIMADOS_MES, /*TOTAL DE COMENSAIS ESTIMADOS DO MES ATUAL*/
        ISNULL(CARD.EFETIVOS,0) EFETIVOS,/*TOTAL DE EFETIVOS DO MES ATUAL*/
        ISNULL(CARD.EFETIVOS_ANT,0) EFETIVOS_ANT, /*TOTAL DE EFETIVOS DO MES ANTERIOR*/
        ISNULL(CARD.ESTIMADOS_ANT,0) ESTIMADOS_ANT, /*TOTAL DE COMENSAIS ESTIMADOS DO MES ANTERIOR*/
        ISNULL(CARD.ESTIMADOS_PROX_MES,0) ESTIMADOS_PROX_MES, /*TOTAL DE COMENSAIS ESTIMADOS DO PROXIMO MES*/
        ISNULL(CARDPOS.ESTIMADOS_POS_DTPROC,0) ESTIMADOS_POS_DTPROC, /*TOTAL DE COMENSAIS ESTIMADOS DA DATA DE PROCESSAMENTO AO FINAL DO MES ATUAL*/
        ISNULL(PU_PLAN.VRCUSTO_ATUAL,0) VRCUSTO_ATUAL, /*CUSTO TOTAL PLANEJADO DO MES ATUAL*/ 
        ISNULL(PU_PLAN.VRCUSTO_ANT,0) VRCUSTO_ANT, /*CUSTO TOTAL PLANEJADO DO MES ANTERIOR*/
        ISNULL(PU_PLAN.VRCUSTO_APOS,0) VRCUSTO_APOS, /*CUSTO TOTAL PLANEJADO DO PRXIMO MES*/
        ISNULL(PU_PLAN.VRCUSTO_POSDT,0) VRCUSTO_POSDT, /*CUSTO TOTAL PLANEJADO APOS A DATA DE PROCESSAMENTO ATE O FIM DO MES*/
        ISNULL(CUSTO_REAL.CUSTO_REAL_MES,0) CUSTO_REAL_MES, /*CUSTO REALIZADO DO MES ATUAL*/
        ISNULL(CUSTO_REAL.CUSTO_REAL_ANT,0) CUSTO_REAL_ANT, /*CUSTO REALIZADO DO MES ANTERIOR*/         
        ISNULL(CPR_DTPROC_ANT.VRCUSTPADR,0) AS PU_PADR_MES_DTPROC_MENOS_UM , /* CUSTO PADRAO REFERENTE AO MES DA DATA DE PROCESSAMENTO - 1*/        
        ISNULL(CUSTO_REAL.CUSTO_REAL_MES_DTPROC_MENOS_UM, 0) AS CUSTO_REAL_MES_DTPROC_MENOS_UM, /*CUSTO REALIZADO DO PRIMEIRO DIA DA DATA DE PROCESSAMENTO - 1 ATE A DATA DE PROCESSAMENTO - 1*/
        ISNULL(PU_PLAN.CUSTO_PLA_MES_DTPROC_MENOS_UM, 0) AS CUSTO_PLA_MES_DTPROC_MENOS_UM, /*CUSTO PLANEJADO DO PRIMEIRO DIA DA DATA DE PROCESSAMENTO - 1 ATE A DATA DE PROCESSAMENTO - 1*/ 
        ISNULL(CARD.EFETIVOS_DTPROC_MENOS_UM,0) AS EFETIVOS_DTPROC_MENOS_UM,/*COMENSAIS EFETIVOS DO DIA ANTERIOR A DATA DE PROCESSAMENTO*/
        ISNULL(CARD.ESTIMADOS_DTPROC_MENOS_UM,0) AS ESTIMADOS_DTPROC_MENOS_UM,/*COMENSAIS ESTIMADOS DO DIA ANTERIOR A DATA DE PROCESSAMENTO*/
        ISNULL(CUSTO_REAL.CUSTO_REAL_DTPROC_MENOS_UM, 0) AS CUSTO_REAL_DTPROC_MENOS_UM, /*CUSTO REALIZADO DO DIA ANTERIOR A DATA DE PROCESSAMENTO*/
        ISNULL(PU_PLAN.CUSTO_PLA_DTPROC_MENOS_UM, 0) AS CUSTO_PLA_DTPROC_MENOS_UM /*CUSTO PLANEJADO DO DIA ANTERIOR A DATA DE PROCESSAMENTO*/          
         FROM (SELECT CDFILIAL, CDSERVFILI FROM SERVICO WHERE ((IDSERVPRINC = 'S') OR (IDINDICADOR = 'S'))) SE    /*RETORNA CODIGO E NOME DO SERVIO*/
                        INNER JOIN (SELECT PF.CDFILIAL, CASE PG.IDUTILDTPROC WHEN 'N' THEN GETDATE() ELSE ISNULL(PF.DTPROCESSA,GETDATE())END DTPROCESSA 
                                      FROM PARAMGERAL PG, PARAMFILIAL PF) PFI ON (PFI.CDFILIAL = SE.CDFILIAL)  /*RETORNA INFORMAES REFERENTE AO OPERADOR, FILIAL E DATA DE PROCESSAMENTO*/
                        LEFT JOIN CUSTPADR CPR ON ((SE.CDFILIAL = CPR.CDFILIAL) AND  /* CUSTO PADRAO, OU PU_OBJETIVO*/
                                                   (SE.CDSERVFILI = CPR.CDSERVFILI) AND 
                                                   (((PFI.DTPROCESSA - DAY(PFI.DTPROCESSA)) + 1) = CPR.DTREFCUSPADR ))
                        LEFT JOIN CUSTPADR CPR_DTPROC_ANT ON ((SE.CDFILIAL = CPR_DTPROC_ANT.CDFILIAL) AND  /* CUSTO PADRAO REFERENTE AO MES DA DATA DE PROCESSAMENTO - 1*/
                                                              (SE.CDSERVFILI = CPR_DTPROC_ANT.CDSERVFILI) AND 
                                                              ((CONVERT(DATE,((PFI.DTPROCESSA - 1) - DAY(PFI.DTPROCESSA - 1)+ 1))) = CPR_DTPROC_ANT.DTREFCUSPADR ))
                        /*SOMA DE COMENSAIS ESTIMADOS E EFETIVOS DO MES INTEIRO, DO MES ANTERIOR E DO PRXIMO MES*/                           
                        LEFT JOIN (SELECT 
                                      CD_MES.CDFILIAL, 
                                      CD_MES.CDSERVFILI, 
                                      CD_MES.ESTIMADOS_MES, 
                                      CD_REAL_MES.EFETIVOS, 
                                      CD_ANT.EFETIVOS_ANT, 
                                      CD_ANT.ESTIMADOS_ANT, 
                                      CD_APOS.ESTIMADOS_PROX_MES,
                                      EFET_DTPROC_MENOS_UM.EFETIVOS_DTPROC_MENOS_UM,
                                      EST_DTPROC_MENOS_UM.ESTIMADOS_DTPROC_MENOS_UM
                                     FROM
                                      (SELECT CD.CDFILIAL, CD.CDSERVFILI, SUM(CASE PFI.IDCOMCUSPERC WHEN 'T' THEN ISNULL(CD.QTCOMEFETCAR,0) ELSE ISNULL(CD.QTCLIEFETCAR,0) END ) EFETIVOS     
                                                   FROM CARDADIA CD INNER JOIN SERVICO SE ON ((SE.CDFILIAL = CD.CDFILIAL) AND (SE.CDSERVFILI = CD.CDSERVFILI))
                                                                    INNER JOIN (SELECT PF.CDFILIAL,PF.IDCOMCUSPERC ,CASE PG.IDUTILDTPROC WHEN 'N' THEN GETDATE() ELSE ISNULL(PF.DTPROCESSA,GETDATE())END DTPROCESSA
                                                                                  FROM PARAMGERAL PG, PARAMFILIAL PF) PFI ON (CD.CDFILIAL = PFI.CDFILIAL) 
                                                  WHERE  (CD.DTCARDAPIO BETWEEN (PFI.DTPROCESSA - DAY(PFI.DTPROCESSA)+ 1) AND 
                                                                                   (PFI.DTPROCESSA - 1))                                                   
                                                  GROUP BY CD.CDFILIAL, CD.CDSERVFILI)CD_REAL_MES
                                      LEFT JOIN
                                      (SELECT CD.CDFILIAL, CD.CDSERVFILI, SUM(CASE PFI.IDCOMCUSPERC WHEN 'T' THEN ISNULL(CD.QTCOMESTICAR,0) ELSE ISNULL(CD.QTCLIESTICAR,0) END ) ESTIMADOS_MES  
                                                   FROM CARDADIA CD INNER JOIN SERVICO SE ON ((SE.CDFILIAL = CD.CDFILIAL) AND (SE.CDSERVFILI = CD.CDSERVFILI))
                                                                    INNER JOIN (SELECT PF.CDFILIAL, PF.IDCOMCUSPERC, CASE PG.IDUTILDTPROC WHEN 'N' THEN GETDATE() ELSE ISNULL(PF.DTPROCESSA,GETDATE())END DTPROCESSA 
																				  FROM PARAMGERAL PG, PARAMFILIAL PF) PFI ON (CD.CDFILIAL = PFI.CDFILIAL) 
                                                  WHERE  (CD.DTCARDAPIO BETWEEN (PFI.DTPROCESSA - DAY(PFI.DTPROCESSA)+ 1) AND 
                                                                                   DATEADD(MM,1,PFI.DTPROCESSA) - DAY(PFI.DTPROCESSA))                                                   
                                                  GROUP BY CD.CDFILIAL, CD.CDSERVFILI) CD_MES
                                       ON ((CD_REAL_MES.CDFILIAL = CD_MES.CDFILIAL) AND (CD_REAL_MES.CDSERVFILI = CD_MES.CDSERVFILI)) 
                                       LEFT JOIN 
                                                  
                                      (SELECT CD.CDFILIAL, CD.CDSERVFILI, SUM(CASE PFI.IDCOMCUSPERC WHEN 'T' THEN ISNULL(CD.QTCOMESTICAR,0) ELSE ISNULL(CD.QTCLIESTICAR,0) END ) ESTIMADOS_ANT,
                                                        SUM(CASE PFI.IDCOMCUSPERC WHEN 'T' THEN ISNULL(CD.QTCOMEFETCAR,0) ELSE ISNULL(CD.QTCLIEFETCAR,0)END ) EFETIVOS_ANT    
                                                   FROM CARDADIA CD INNER JOIN SERVICO SE ON ((SE.CDFILIAL = CD.CDFILIAL) AND (SE.CDSERVFILI = CD.CDSERVFILI))
                                                                    INNER JOIN (SELECT PF.CDFILIAL, PF.IDCOMCUSPERC ,CASE PG.IDUTILDTPROC WHEN 'N' THEN GETDATE() ELSE ISNULL(PF.DTPROCESSA,GETDATE())END DTPROCESSA 
																				  FROM PARAMGERAL PG, PARAMFILIAL PF) PFI ON (CD.CDFILIAL = PFI.CDFILIAL) 
                                                  WHERE  (CD.DTCARDAPIO BETWEEN DATEADD(MM,-1,(PFI.DTPROCESSA - DAY(PFI.DTPROCESSA)+ 1)) AND 
                                                                                   DATEADD(MM,-1,  DATEADD(MM,1,PFI.DTPROCESSA) - DAY(PFI.DTPROCESSA)))
                                                  GROUP BY CD.CDFILIAL, CD.CDSERVFILI) CD_ANT 
                                       ON ((CD_ANT.CDFILIAL = CD_MES.CDFILIAL) AND (CD_ANT.CDSERVFILI = CD_MES.CDSERVFILI)) 
                                       LEFT JOIN           
                                      (SELECT CD.CDFILIAL, CD.CDSERVFILI, SUM(CASE PFI.IDCOMCUSPERC WHEN 'T' THEN ISNULL(CD.QTCOMESTICAR,0) ELSE ISNULL(CD.QTCLIESTICAR,0) END) ESTIMADOS_PROX_MES
                                                   FROM CARDADIA CD INNER JOIN SERVICO SE ON ((SE.CDFILIAL = CD.CDFILIAL) AND (SE.CDSERVFILI = CD.CDSERVFILI))
                                                                    INNER JOIN (SELECT PF.CDFILIAL,PF.IDCOMCUSPERC ,CASE PG.IDUTILDTPROC WHEN 'N' THEN GETDATE() ELSE ISNULL(PF.DTPROCESSA,GETDATE())END DTPROCESSA 
																				  FROM PARAMGERAL PG, PARAMFILIAL PF) PFI ON (CD.CDFILIAL = PFI.CDFILIAL) 
                                                  WHERE  (CD.DTCARDAPIO BETWEEN DATEADD(MM,1,(PFI.DTPROCESSA - DAY(PFI.DTPROCESSA)+ 1)) AND 
                                                                                DATEADD(MM,1,DATEADD(MM,1,PFI.DTPROCESSA) - DAY(PFI.DTPROCESSA)))
                                                  GROUP BY CD.CDFILIAL, CD.CDSERVFILI) CD_APOS ON ((CD_APOS.CDFILIAL = CD_MES.CDFILIAL) AND (CD_APOS.CDSERVFILI = CD_MES.CDSERVFILI)) 
                                       LEFT JOIN           
                                      /*CALCULO DO TOTAL DE EFETIVOS DA DATA DE PROCESSAMENTO MENOS UM DIA*/
                                      (SELECT CD.CDFILIAL, CD.CDSERVFILI, SUM(CASE PFI.IDCOMCUSPERC WHEN 'T' THEN ISNULL(CD.QTCOMEFETCAR,0) ELSE ISNULL(CD.QTCLIEFETCAR,0) END ) EFETIVOS_DTPROC_MENOS_UM    
                                                   FROM CARDADIA CD INNER JOIN SERVICO SE ON ((SE.CDFILIAL = CD.CDFILIAL) AND (SE.CDSERVFILI = CD.CDSERVFILI))
                                                                    INNER JOIN (SELECT PF.CDFILIAL,PF.IDCOMCUSPERC ,CASE PG.IDUTILDTPROC WHEN 'N' THEN GETDATE() ELSE ISNULL(PF.DTPROCESSA,GETDATE())END DTPROCESSA
                                                                                  FROM PARAMGERAL PG, PARAMFILIAL PF) PFI ON (CD.CDFILIAL = PFI.CDFILIAL) 
                                                  WHERE  (CD.DTCARDAPIO = CONVERT (DATE, (PFI.DTPROCESSA - 1)))
                                                  GROUP BY CD.CDFILIAL, CD.CDSERVFILI)EFET_DTPROC_MENOS_UM
                                      ON ((CD_REAL_MES.CDFILIAL = EFET_DTPROC_MENOS_UM.CDFILIAL) AND (CD_REAL_MES.CDSERVFILI = EFET_DTPROC_MENOS_UM.CDSERVFILI))
                                      /*FIM DO CALCULO DO TOTAL DE EFETIVOS DA DATA DE PROCESSAMENTO MENOS UM DIA*/
                                      LEFT JOIN
                                      /*CALCULO DO TOTAL DE ESTIMADOS DA DATA DE PROCESSAMENTO MENOS UM DIA*/
                                      (SELECT CD.CDFILIAL, CD.CDSERVFILI, SUM(CASE PFI.IDCOMCUSPERC WHEN 'T' THEN ISNULL(CD.QTCOMESTICAR,0) ELSE ISNULL(CD.QTCLIESTICAR,0) END ) ESTIMADOS_DTPROC_MENOS_UM   
                                                   FROM CARDADIA CD INNER JOIN SERVICO SE ON ((SE.CDFILIAL = CD.CDFILIAL) AND (SE.CDSERVFILI = CD.CDSERVFILI))
                                                                    INNER JOIN (SELECT PF.CDFILIAL, PF.IDCOMCUSPERC, CASE PG.IDUTILDTPROC WHEN 'N' THEN GETDATE() ELSE ISNULL(PF.DTPROCESSA,GETDATE())END DTPROCESSA 
																				  FROM PARAMGERAL PG, PARAMFILIAL PF) PFI ON (CD.CDFILIAL = PFI.CDFILIAL) 
                                                  WHERE  (CD.DTCARDAPIO = CONVERT (DATE, (PFI.DTPROCESSA - 1)))
                                                  GROUP BY CD.CDFILIAL, CD.CDSERVFILI) EST_DTPROC_MENOS_UM  
                                       ON ((CD_REAL_MES.CDFILIAL = EST_DTPROC_MENOS_UM.CDFILIAL) AND (CD_REAL_MES.CDSERVFILI = EST_DTPROC_MENOS_UM.CDSERVFILI))
                                       /*FIM DO CALCULO DO TOTAL DE ESTIMADOS DA DATA DE PROCESSAMENTO MENOS UM DIA*/                                                  
                                 )CARD ON ((SE.CDFILIAL = CARD.CDFILIAL) AND (SE.CDSERVFILI = CARD.CDSERVFILI))
                        /*FIM SOMA DE COMENSAIS ESTIMADOS E EFETIVOS DO MES INTEIRO, DO MES ANTERIOR E DO PRXIMO MES*/  
                                      
                        /*SOMA DE COMENSAIS ESTIMADOS DA DTPROC ATE FIM DO MES*/                           
                        LEFT JOIN (SELECT CD.CDFILIAL, 
                                          CD.CDSERVFILI, 
                                          SUM(CASE PFI.IDCOMCUSPERC WHEN 'T' THEN ISNULL(CD.QTCOMESTICAR,0) ELSE ISNULL(CD.QTCLIESTICAR,0)END) ESTIMADOS_POS_DTPROC 
                                     FROM CARDADIA CD INNER JOIN SERVICO SE ON ((SE.CDFILIAL = CD.CDFILIAL) AND (SE.CDSERVFILI = CD.CDSERVFILI))
                                                      INNER JOIN (SELECT PF.CDFILIAL,PF.IDCOMCUSPERC ,CASE PG.IDUTILDTPROC WHEN 'N' THEN GETDATE() ELSE ISNULL(PF.DTPROCESSA,GETDATE())END DTPROCESSA 
																	FROM PARAMGERAL PG, PARAMFILIAL PF) PFI ON (CD.CDFILIAL = PFI.CDFILIAL)
                                    WHERE CD.DTCARDAPIO BETWEEN PFI.DTPROCESSA AND DATEADD(MM,1,PFI.DTPROCESSA) - DAY(PFI.DTPROCESSA)
                                 GROUP BY CD.CDFILIAL, CD.CDSERVFILI
                                 )CARDPOS ON ((SE.CDFILIAL = CARDPOS.CDFILIAL) AND 
                                              (SE.CDSERVFILI = CARDPOS.CDSERVFILI))
                        /*FIM SOMA DE COMENSAIS ESTIMADOS E EFETIVOS DO MES INTEIRO, DO MES ANTERIOR E DO PRXIMO MES*/                         
                        /*CALCULA CUSTO TOTAL PLANEJADO ATUAL, DO MES ANTERIOR E DO PROXIMO MES*/
                        LEFT JOIN (SELECT 
                                      C_ATUAL.CDFILICPLA, 
                                      C_ATUAL.CDSERVCPLA, 
                                      C_ATUAL.VRCUSTO_ATUAL,
                                      C_PLA_MES_DTPROC_MENOS_UM.CUSTO_PLA_MES_DTPROC_MENOS_UM,
                                      C_ANTES.VRCUSTO_ANT, 
                                      C_APOS.VRCUSTO_APOS, 
                                      C_POSDT.VRCUSTO_POSDT,
                                      C_PLA_DTPROC_MENOS_UM.CUSTO_PLA_DTPROC_MENOS_UM
                                     FROM
                                      (SELECT
                                           CP.CDFILICPLA, CP.CDSERVCPLA, 
                                           SUM(TEKNISA.CUSTO_PRODUTO(CP.CDFILICPLA, CP.CDPRODCPLA, ISNULL(PP.CDTIPOCUSTOPLA, '03'), 
                                               CASE PP.IDEXIBECUSTO WHEN 'R' THEN ISNULL(CM.DTREFECUSTMES, CP.DTCONSPLAN) ELSE CP.DTCONSPLAN END, GETDATE()) * CP.QTCONSPLAN) AS VRCUSTO_ATUAL
                                        FROM
                                           CONSPLAN CP LEFT JOIN CARDAMES CM ON ((CP.CDFILICPLA = CM.CDFILIAL) AND
                                                                                 (CP.CDSERVCPLA = CM.CDSERVFILI) AND 
                                                                                 ((CP.DTCONSPLAN - DAY(CP.DTCONSPLAN) + 1) = CM.DTMESCARDAPIO))
                                                       INNER JOIN PARAMPLANEJA PP ON (CP.CDFILICPLA = PP.CDFILIAL)
                                                       INNER JOIN (SELECT PF.CDFILIAL, CASE PG.IDUTILDTPROC WHEN 'N' THEN GETDATE() ELSE ISNULL(PF.DTPROCESSA,GETDATE())END DTPROCESSA 
																	 FROM PARAMGERAL PG, PARAMFILIAL PF) PFI ON (PFI.CDFILIAL = CP.CDFILICPLA)
                                        WHERE
                                           (CP.NRCONSPLAN    = @V_NRCONSPLAN) AND
                                           (CP.DTCONSPLAN BETWEEN (PFI.DTPROCESSA - DAY(PFI.DTPROCESSA) + 1) AND DATEADD(MM,1,PFI.DTPROCESSA) - DAY(PFI.DTPROCESSA))
                                        GROUP BY
                                           CP.CDFILICPLA, CP.CDSERVCPLA, (CP.DTCONSPLAN - DAY(CP.DTCONSPLAN) + 1)) C_ATUAL
                                      LEFT JOIN
                                      
                                       /*CALCULO DO CUSTO PLANEJADO DO PRIMEIRO DIA DA DATA DE PROCESSAMENTO - 1 ATE A DATA DE PROCESSAMENTO - 1*/ 
                                      (SELECT
                                           CP.CDFILICPLA, CP.CDSERVCPLA, 
                                           SUM(TEKNISA.CUSTO_PRODUTO(CP.CDFILICPLA, CP.CDPRODCPLA, ISNULL(PP.CDTIPOCUSTOPLA, '03'), 
                                               CASE PP.IDEXIBECUSTO WHEN 'R' THEN ISNULL(CM.DTREFECUSTMES, CP.DTCONSPLAN) ELSE CP.DTCONSPLAN END, GETDATE()) * CP.QTCONSPLAN) AS CUSTO_PLA_MES_DTPROC_MENOS_UM
                                        FROM
                                           CONSPLAN CP LEFT JOIN CARDAMES CM ON ((CP.CDFILICPLA = CM.CDFILIAL) AND
                                                                                 (CP.CDSERVCPLA = CM.CDSERVFILI) AND
                                                                                 ((CP.DTCONSPLAN - DAY(CP.DTCONSPLAN) + 1) = CM.DTMESCARDAPIO))
                                                       INNER JOIN PARAMPLANEJA PP ON (CP.CDFILICPLA = PP.CDFILIAL)
                                                       INNER JOIN (SELECT PF.CDFILIAL, CASE PG.IDUTILDTPROC WHEN 'N' THEN GETDATE() ELSE ISNULL(PF.DTPROCESSA,GETDATE())END DTPROCESSA 
																	 FROM PARAMGERAL PG, PARAMFILIAL PF) PFI ON (PFI.CDFILIAL = CP.CDFILICPLA)
                                        WHERE
                                           (CP.NRCONSPLAN    = @V_NRCONSPLAN) AND
                                           (CP.DTCONSPLAN BETWEEN CONVERT(DATE,((PFI.DTPROCESSA - 1) - DAY(PFI.DTPROCESSA - 1)+ 1)) AND CONVERT (DATE, (PFI.DTPROCESSA - 1)))
                                        GROUP BY
                                           CP.CDFILICPLA, CP.CDSERVCPLA, (CP.DTCONSPLAN - DAY(CP.DTCONSPLAN) + 1)) C_PLA_MES_DTPROC_MENOS_UM ON ((C_ATUAL.CDFILICPLA = C_PLA_MES_DTPROC_MENOS_UM.CDFILICPLA) AND 
                                                                                                                                                 (C_ATUAL.CDSERVCPLA = C_PLA_MES_DTPROC_MENOS_UM.CDSERVCPLA))
                                        /*FIM DO CALCULO DO CUSTO PLANEJADO DO PRIMEIRO DIA DA DATA DE PROCESSAMENTO - 1 ATE A DATA DE PROCESSAMENTO - 1*/                                        
                                      LEFT JOIN
                                      (SELECT
                                           CP.CDFILICPLA, CP.CDSERVCPLA,
                                           SUM(TEKNISA.CUSTO_PRODUTO(CP.CDFILICPLA, CP.CDPRODCPLA, ISNULL(PP.CDTIPOCUSTOPLA, '03'), 
                                               CASE PP.IDEXIBECUSTO WHEN 'R' THEN ISNULL(CM.DTREFECUSTMES, CP.DTCONSPLAN) ELSE CP.DTCONSPLAN END, GETDATE()) * CP.QTCONSPLAN) AS VRCUSTO_ANT
                                        FROM
                                           CONSPLAN CP LEFT JOIN CARDAMES CM ON ((CP.CDFILICPLA = CM.CDFILIAL) AND
                                                                                 (CP.CDSERVCPLA = CM.CDSERVFILI) AND 
                                                                                 ((CP.DTCONSPLAN - DAY(CP.DTCONSPLAN) + 1) = CM.DTMESCARDAPIO))
                                                       INNER JOIN PARAMPLANEJA PP ON (CP.CDFILICPLA = PP.CDFILIAL)
                                                       INNER JOIN (SELECT PF.CDFILIAL, CASE PG.IDUTILDTPROC WHEN 'N' THEN GETDATE() ELSE ISNULL(PF.DTPROCESSA,GETDATE())END DTPROCESSA 
																	 FROM PARAMGERAL PG, PARAMFILIAL PF) PFI ON (PFI.CDFILIAL = CP.CDFILICPLA)
                                        WHERE
                                           (CP.NRCONSPLAN    = @V_NRCONSPLAN) AND
                                           (CP.DTCONSPLAN BETWEEN DATEADD(MM,-1,(PFI.DTPROCESSA - DAY(PFI.DTPROCESSA) + 1)) 
                                                              AND DATEADD(MM,-1,DATEADD(MM,1,PFI.DTPROCESSA) - DAY(PFI.DTPROCESSA)))
                                        GROUP BY
                                           CP.CDFILICPLA, CP.CDSERVCPLA, (CP.DTCONSPLAN - DAY(CP.DTCONSPLAN) + 1)) C_ANTES ON ((C_ATUAL.CDFILICPLA = C_ANTES.CDFILICPLA) AND 
                                                                                                                                     (C_ATUAL.CDSERVCPLA = C_ANTES.CDSERVCPLA))
                                                                                                                                               
                                      LEFT JOIN  
                                      (SELECT
                                           CP.CDFILICPLA, CP.CDSERVCPLA,
                                           SUM(TEKNISA.CUSTO_PRODUTO(CP.CDFILICPLA, CP.CDPRODCPLA, ISNULL(PP.CDTIPOCUSTOPLA, '03'), 
                                               CASE PP.IDEXIBECUSTO WHEN 'R' THEN ISNULL(CM.DTREFECUSTMES, CP.DTCONSPLAN) ELSE CP.DTCONSPLAN END, GETDATE()) * CP.QTCONSPLAN) AS VRCUSTO_APOS
                                        FROM
                                           CONSPLAN CP LEFT JOIN CARDAMES CM ON ((CP.CDFILICPLA = CM.CDFILIAL) AND
                                                                                 (CP.CDSERVCPLA = CM.CDSERVFILI) AND 
                                                                                 ((CP.DTCONSPLAN - DAY(CP.DTCONSPLAN) + 1) = CM.DTMESCARDAPIO))
                                                       INNER JOIN PARAMPLANEJA PP ON (CP.CDFILICPLA = PP.CDFILIAL)
                                                       INNER JOIN (SELECT PF.CDFILIAL, CASE PG.IDUTILDTPROC WHEN 'N' THEN GETDATE() ELSE ISNULL(PF.DTPROCESSA,GETDATE())END DTPROCESSA 
																	 FROM PARAMGERAL PG, PARAMFILIAL PF) PFI ON (PFI.CDFILIAL = CP.CDFILICPLA)
                                        WHERE
                                           (CP.NRCONSPLAN    = @V_NRCONSPLAN) AND
                                           (CP.DTCONSPLAN BETWEEN DATEADD(MM,1,(PFI.DTPROCESSA - DAY(PFI.DTPROCESSA) + 1)) 
                                                              AND DATEADD(MM,1, DATEADD(MM,1,PFI.DTPROCESSA) - DAY(PFI.DTPROCESSA)))
                                        GROUP BY
                                           CP.CDFILICPLA, CP.CDSERVCPLA, (CP.DTCONSPLAN - DAY(CP.DTCONSPLAN) + 1)) C_APOS ON ((C_ATUAL.CDFILICPLA = C_APOS.CDFILICPLA) AND 
                                                                                                                                    (C_ATUAL.CDSERVCPLA = C_APOS.CDSERVCPLA))
                                      LEFT JOIN
                                      (SELECT
                                           CP.CDFILICPLA, CP.CDSERVCPLA,
                                           SUM(TEKNISA.CUSTO_PRODUTO(CP.CDFILICPLA, CP.CDPRODCPLA, ISNULL(PP.CDTIPOCUSTOPLA, '03'), 
                                               CASE PP.IDEXIBECUSTO WHEN 'R' THEN ISNULL(CM.DTREFECUSTMES, CP.DTCONSPLAN) ELSE CP.DTCONSPLAN END, GETDATE()) * CP.QTCONSPLAN) AS VRCUSTO_POSDT
                                        FROM
                                           CONSPLAN CP LEFT JOIN CARDAMES CM ON ((CP.CDFILICPLA = CM.CDFILIAL) AND
                                                                                 (CP.CDSERVCPLA = CM.CDSERVFILI) AND 
                                                                                 ((CP.DTCONSPLAN - DAY(CP.DTCONSPLAN) + 1) = CM.DTMESCARDAPIO))
                                                       INNER JOIN PARAMPLANEJA PP ON (CP.CDFILICPLA = PP.CDFILIAL)
                                                       INNER JOIN (SELECT PF.CDFILIAL, CASE PG.IDUTILDTPROC WHEN 'N' THEN GETDATE() ELSE ISNULL(PF.DTPROCESSA,GETDATE())END DTPROCESSA 
																	 FROM PARAMGERAL PG, PARAMFILIAL PF) PFI ON (PFI.CDFILIAL = CP.CDFILICPLA)
                                        WHERE
                                           (CP.NRCONSPLAN    = @V_NRCONSPLAN) AND
                                           (CP.DTCONSPLAN BETWEEN PFI.DTPROCESSA 
                                                              AND DATEADD(MM,1,PFI.DTPROCESSA) - DAY(PFI.DTPROCESSA))
                                        GROUP BY
                                           CP.CDFILICPLA, CP.CDSERVCPLA, (CP.DTCONSPLAN - DAY(CP.DTCONSPLAN) + 1)) C_POSDT ON ((C_POSDT.CDFILICPLA = C_ATUAL.CDFILICPLA) AND 
                                                                                                                              (C_POSDT.CDSERVCPLA = C_ATUAL.CDSERVCPLA))
                                      LEFT JOIN 
                                      
                                      (SELECT
                                           CP.CDFILICPLA, CP.CDSERVCPLA, 
                                           SUM(TEKNISA.CUSTO_PRODUTO(CP.CDFILICPLA, CP.CDPRODCPLA, ISNULL(PP.CDTIPOCUSTOPLA, '03'), 
                                               CASE PP.IDEXIBECUSTO WHEN 'R' THEN ISNULL(CM.DTREFECUSTMES, CP.DTCONSPLAN) ELSE CP.DTCONSPLAN END, GETDATE()) * CP.QTCONSPLAN) AS CUSTO_PLA_DTPROC_MENOS_UM
                                        FROM
                                           CONSPLAN CP LEFT JOIN CARDAMES CM ON ((CP.CDFILICPLA = CM.CDFILIAL) AND
                                                                                 (CP.CDSERVCPLA = CM.CDSERVFILI) AND 
                                                                                 ((CP.DTCONSPLAN - DAY(CP.DTCONSPLAN) + 1) = CM.DTMESCARDAPIO))
                                                       INNER JOIN PARAMPLANEJA PP ON (CP.CDFILICPLA = PP.CDFILIAL)
                                                       INNER JOIN (SELECT PF.CDFILIAL, CASE PG.IDUTILDTPROC WHEN 'N' THEN GETDATE() ELSE ISNULL(PF.DTPROCESSA,GETDATE())END DTPROCESSA 
																	 FROM PARAMGERAL PG, PARAMFILIAL PF) PFI ON (PFI.CDFILIAL = CP.CDFILICPLA)
                                        WHERE
                                           (CP.NRCONSPLAN    = @V_NRCONSPLAN) AND
                                           (CP.DTCONSPLAN = CONVERT (DATE, (PFI.DTPROCESSA - 1)))
                                        GROUP BY
                                           CP.CDFILICPLA, CP.CDSERVCPLA, (CP.DTCONSPLAN - DAY(CP.DTCONSPLAN) + 1)) C_PLA_DTPROC_MENOS_UM ON ((C_ATUAL.CDFILICPLA = C_PLA_DTPROC_MENOS_UM.CDFILICPLA) AND 
                                                                                                                                             (C_ATUAL.CDSERVCPLA = C_PLA_DTPROC_MENOS_UM.CDSERVCPLA))
                                           
                                  ) PU_PLAN ON ((SE.CDFILIAL = PU_PLAN.CDFILICPLA) AND 
                                                (SE.CDSERVFILI = PU_PLAN.CDSERVCPLA))
                        /*FIM CALCULA CUSTO TOTAL PLANEJADO ATUAL, DO MES ANTERIOR E DO PROXIMO MES*/                         
                        /*CALCULA CUSTO REAL DO MES ATUAL ATE A DATA DE PROCESSAMENTO E DO ANTERIOR*/
                        LEFT JOIN (SELECT CUS_MES.CDFILIAL, 
                                          CUS_MES.CDSERVFILI, 
                                          CUS_MES.CUSTO_REAL_MES, 
                                          CUS_MES_DTPROC_MENOS_UM.CUSTO_REAL_MES_DTPROC_MENOS_UM,
                                          CUS_ANT.CUSTO_REAL_ANT,
                                          C_REAL_DTPROC_MENOS_UM.CUSTO_REAL_DTPROC_MENOS_UM
                                     FROM 
                                        (SELECT
                                          CD.CDFILIAL, 
                                          CD.CDSERVFILI,
                                          ROUND(SUM(IR.QTRETIRADA * TEKNISA.CUSTO_PRODUTO(CD.CDFILIAL, IR.CDPRODUTO, ISNULL(PP.CDTIPOCUSTOREA, '03'),
                                                                  CASE PP.IDEXIBECUSTO WHEN 'R' THEN ISNULL(CM.DTREFECUSTMES, CD.DTCARDAPIO) ELSE CD.DTCARDAPIO END, GETDATE())),5) AS CUSTO_REAL_MES
                                           FROM
                                              RETIRADA R INNER JOIN CARDADIA CD ON ((R.CDFILIAL = CD.CDFILIAL)      AND 
                                                                                    (R.NRCARDAPIO = CD.NRCARDAPIO)) 
                                                         INNER JOIN ITEMRETI IR ON ((IR.CDFILIAL = R.CDFILIAL)     AND 
                                                                                    (IR.NRCARDAPIO = R.NRCARDAPIO) AND 
                                                                                    (IR.NRRETIRADA = R.NRRETIRADA))
                                                         INNER JOIN ITLANCTOEST IL ON ((IL.CDFILIAL = IR.CDFIITLANEST) AND 
                                                                                       (IL.NRLANCESTQ = IR.NRLANCESTQ) AND 
                                                                                       (IL.NRSEQUITEM = IR.NRSEQUITEM))
                                                         INNER JOIN PARAMPLANEJA PP ON (PP.CDFILIAL = CD.CDFILIAL)
                                                         INNER JOIN (SELECT PF.CDFILIAL, CASE PG.IDUTILDTPROC WHEN 'N' THEN GETDATE() ELSE ISNULL(PF.DTPROCESSA,GETDATE())END DTPROCESSA 
																	   FROM PARAMGERAL PG, PARAMFILIAL PF) PFI ON (PFI.CDFILIAL = CD.CDFILIAL)
                                                         LEFT JOIN CARDAMES CM ON ((CD.CDFILIAL   =  CM.CDFILIAL)  AND 
                                                                                   (CD.CDSERVFILI = CM.CDSERVFILI) AND 
                                                                                   (CD.DTMESCARD  = CM.DTMESCARDAPIO))
                                          WHERE
                                              (CD.DTCARDAPIO   BETWEEN (PFI.DTPROCESSA - DAY(PFI.DTPROCESSA) + 1) 
                                                                   AND (PFI.DTPROCESSA - 1)) AND
                                              IL.IDEVOLESTOQ = 'S'
                                          GROUP BY CD.CDFILIAL, CD.CDSERVFILI) CUS_MES 
                                     LEFT JOIN                                     
                                     /*CALCULO DO CUSTO REALIZADO DO PRIMEIRO DIA DA DATA DE PROCESSAMENTO - 1 ATE A DATA DE PROCESSAMENTO - 1*/
                                        (SELECT
                                          CD.CDFILIAL, 
                                          CD.CDSERVFILI,
                                          ROUND(SUM(IR.QTRETIRADA * TEKNISA.CUSTO_PRODUTO(CD.CDFILIAL, IR.CDPRODUTO, ISNULL(PP.CDTIPOCUSTOREA, '03'),
                                                                  CASE PP.IDEXIBECUSTO WHEN 'R' THEN ISNULL(CM.DTREFECUSTMES, CD.DTCARDAPIO) ELSE CD.DTCARDAPIO END, GETDATE())),5) AS CUSTO_REAL_MES_DTPROC_MENOS_UM
                                           FROM
                                              RETIRADA R INNER JOIN CARDADIA CD ON ((R.CDFILIAL = CD.CDFILIAL)      AND 
                                                                                    (R.NRCARDAPIO = CD.NRCARDAPIO)) 
                                                         INNER JOIN ITEMRETI IR ON ((IR.CDFILIAL = R.CDFILIAL)     AND 
                                                                                    (IR.NRCARDAPIO = R.NRCARDAPIO) AND 
                                                                                    (IR.NRRETIRADA = R.NRRETIRADA))
                                                         INNER JOIN ITLANCTOEST IL ON ((IL.CDFILIAL = IR.CDFIITLANEST) AND 
                                                                                       (IL.NRLANCESTQ = IR.NRLANCESTQ) AND 
                                                                                       (IL.NRSEQUITEM = IR.NRSEQUITEM))
                                                         INNER JOIN PARAMPLANEJA PP ON (PP.CDFILIAL = CD.CDFILIAL)
                                                         INNER JOIN (SELECT PF.CDFILIAL, CASE PG.IDUTILDTPROC WHEN 'N' THEN GETDATE() ELSE ISNULL(PF.DTPROCESSA,GETDATE())END DTPROCESSA 
																	   FROM PARAMGERAL PG, PARAMFILIAL PF) PFI ON (PFI.CDFILIAL = CD.CDFILIAL)
                                                         LEFT JOIN CARDAMES CM ON ((CD.CDFILIAL   =  CM.CDFILIAL)  AND 
                                                                                   (CD.CDSERVFILI = CM.CDSERVFILI) AND 
                                                                                   (CD.DTMESCARD  = CM.DTMESCARDAPIO))
                                          WHERE
                                              (CD.DTCARDAPIO BETWEEN CONVERT(DATE,((PFI.DTPROCESSA - 1) - DAY(PFI.DTPROCESSA - 1)+ 1)) AND CONVERT (DATE, (PFI.DTPROCESSA - 1))) AND
                                              IL.IDEVOLESTOQ = 'S'
                                          GROUP BY CD.CDFILIAL, CD.CDSERVFILI) CUS_MES_DTPROC_MENOS_UM 
                                          /* FIM DO CALCULO DO CUSTO REALIZADO DO PRIMEIRO DIA DA DATA DE PROCESSAMENTO - 1 ATE A DATA DE PROCESSAMENTO - 1*/
                                     ON ((CUS_MES.CDFILIAL = CUS_MES_DTPROC_MENOS_UM.CDFILIAL) AND (CUS_MES.CDSERVFILI = CUS_MES_DTPROC_MENOS_UM.CDSERVFILI)) 
                                     LEFT JOIN 
                                        (SELECT
                                          CD.CDFILIAL, 
                                          CD.CDSERVFILI,
                                          ROUND(SUM(IR.QTRETIRADA * TEKNISA.CUSTO_PRODUTO(CD.CDFILIAL, IR.CDPRODUTO, ISNULL(PP.CDTIPOCUSTOREA, '03'),
                                                                  CASE PP.IDEXIBECUSTO WHEN 'R' THEN ISNULL(CM.DTREFECUSTMES, CD.DTCARDAPIO) ELSE CD.DTCARDAPIO END, GETDATE())),5) AS CUSTO_REAL_ANT
                                           FROM
                                              RETIRADA R INNER JOIN CARDADIA CD ON ((R.CDFILIAL = CD.CDFILIAL)      AND 
                                                                                    (R.NRCARDAPIO = CD.NRCARDAPIO)) 
                                                         INNER JOIN ITEMRETI IR ON ((IR.CDFILIAL = R.CDFILIAL)     AND 
                                                                                    (IR.NRCARDAPIO = R.NRCARDAPIO) AND 
                                                                                    (IR.NRRETIRADA = R.NRRETIRADA))
                                                         INNER JOIN ITLANCTOEST IL ON ((IL.CDFILIAL = IR.CDFIITLANEST) AND 
                                                                                       (IL.NRLANCESTQ = IR.NRLANCESTQ) AND 
                                                                                       (IL.NRSEQUITEM = IR.NRSEQUITEM))
                                                         INNER JOIN PARAMPLANEJA PP ON (PP.CDFILIAL = CD.CDFILIAL)
                                                         INNER JOIN (SELECT PF.CDFILIAL, CASE PG.IDUTILDTPROC WHEN 'N' THEN GETDATE() ELSE ISNULL(PF.DTPROCESSA,GETDATE())END DTPROCESSA 
																	   FROM PARAMGERAL PG, PARAMFILIAL PF) PFI ON (PFI.CDFILIAL = CD.CDFILIAL)
                                                         LEFT JOIN CARDAMES CM ON ((CD.CDFILIAL   =  CM.CDFILIAL)  AND 
                                                                                   (CD.CDSERVFILI = CM.CDSERVFILI) AND 
                                                                                   (CD.DTMESCARD  = CM.DTMESCARDAPIO))
                                           WHERE
                                              (CD.DTCARDAPIO   BETWEEN DATEADD(MM,1,(PFI.DTPROCESSA - DAY(PFI.DTPROCESSA) + 1)) 
                                                                   AND DATEADD(MM,1,(DATEADD(MM,1,PFI.DTPROCESSA) - DAY(PFI.DTPROCESSA)))) AND
                                              IL.IDEVOLESTOQ = 'S'
                                           GROUP BY
                                              CD.CDFILIAL, 
                                              CD.CDSERVFILI) CUS_ANT 
                                     ON ((CUS_MES.CDFILIAL = CUS_ANT.CDFILIAL) AND (CUS_MES.CDSERVFILI = CUS_ANT.CDSERVFILI))
                                     LEFT JOIN
                                     /*CALCULO DO CUSTO REALIZADO DA DATA DE PROCESSAMENTO MENOS UM DIA*/
                                    (SELECT
                                          CD.CDFILIAL, 
                                          CD.CDSERVFILI,
                                          ROUND(SUM(IR.QTRETIRADA * TEKNISA.CUSTO_PRODUTO(CD.CDFILIAL, IR.CDPRODUTO, ISNULL(PP.CDTIPOCUSTOREA, '03'),
                                                                  CASE PP.IDEXIBECUSTO WHEN 'R' THEN ISNULL(CM.DTREFECUSTMES, CD.DTCARDAPIO) ELSE CD.DTCARDAPIO END, GETDATE())),5) AS CUSTO_REAL_DTPROC_MENOS_UM
                                           FROM
                                              RETIRADA R INNER JOIN CARDADIA CD ON ((R.CDFILIAL = CD.CDFILIAL)      AND 
                                                                                    (R.NRCARDAPIO = CD.NRCARDAPIO)) 
                                                         INNER JOIN ITEMRETI IR ON ((IR.CDFILIAL = R.CDFILIAL)     AND 
                                                                                    (IR.NRCARDAPIO = R.NRCARDAPIO) AND 
                                                                                    (IR.NRRETIRADA = R.NRRETIRADA))
                                                         INNER JOIN ITLANCTOEST IL ON ((IL.CDFILIAL = IR.CDFIITLANEST) AND 
                                                                                       (IL.NRLANCESTQ = IR.NRLANCESTQ) AND 
                                                                                       (IL.NRSEQUITEM = IR.NRSEQUITEM))
                                                         INNER JOIN PARAMPLANEJA PP ON (PP.CDFILIAL = CD.CDFILIAL)
                                                         INNER JOIN (SELECT PF.CDFILIAL, CASE PG.IDUTILDTPROC WHEN 'N' THEN GETDATE() ELSE ISNULL(PF.DTPROCESSA,GETDATE())END DTPROCESSA 
																	   FROM PARAMGERAL PG, PARAMFILIAL PF) PFI ON (PFI.CDFILIAL = CD.CDFILIAL)
                                                         LEFT JOIN CARDAMES CM ON ((CD.CDFILIAL   =  CM.CDFILIAL)  AND 
                                                                                   (CD.CDSERVFILI = CM.CDSERVFILI) AND 
                                                                                   (CD.DTMESCARD  = CM.DTMESCARDAPIO))
                                          WHERE
                                              (CD.DTCARDAPIO = CONVERT (DATE, (PFI.DTPROCESSA - 1))) AND
                                              IL.IDEVOLESTOQ = 'S'
                                          GROUP BY CD.CDFILIAL, CD.CDSERVFILI) C_REAL_DTPROC_MENOS_UM
                                     ON ((C_REAL_DTPROC_MENOS_UM.CDFILIAL = CUS_MES.CDFILIAL) AND (C_REAL_DTPROC_MENOS_UM.CDSERVFILI = CUS_MES.CDSERVFILI))
                                     /*FIM DO CALCULO DO CUSTO REALIZADO DA DATA DE PROCESSAMENTO MENOS UM DIA*/
                                  )CUSTO_REAL ON ((SE.CDFILIAL = CUSTO_REAL.CDFILIAL) AND
                                                  (SE.CDSERVFILI = CUSTO_REAL.CDSERVFILI))
                        /*FIM CALCULA CUSTO REAL DO MES ATUAL ATE A DATA DE PROCESSAMENTO E DO ANTERIOR*/) PLANEJADORA);
   
   DELETE FROM CONSPLAN
    WHERE NRCONSPLAN = @V_NRCONSPLAN;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'ETL_PLANEJADORA','5.75.000';
GO